Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F	(revision 195)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F	(revision 196)
@@ -2884,4 +2947,5 @@
         ENDDO
 
+
       ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
 
@@ -2894,5 +2958,5 @@
             ENDDO
 
-     ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
+     ELSE IF  ( j == jds+2 ) THEN  ! 4th order flux 2 in from south boundary
 
             DO k=kts,ktf
@@ -2939,4 +3003,5 @@
         ENDIF
 
+
         jtmp = jp1
         jp1 = jp0
@@ -2961,5 +3026,6 @@
       IF(degrade_xs) then
         i_start = MAX(ids+1,its)
-        i_start_f = i_start+2
+!        i_start_f = i_start+2
+        i_start_f = MIN(i_start+2,ids+3)
       ENDIF
 
@@ -2989,19 +3055,22 @@
         IF( degrade_xs ) THEN
 
-          IF( i_start == ids+1 ) THEN ! second order flux next to the boundary
-            i = ids+1
-            DO k=kts,ktf
-              fqx(i,k) = 0.5*(ru(i,k,j)) &
-                     *(field(i,k,j)+field(i-1,k,j))
-
-            ENDDO
-          ENDIF
-
-          i = ids+2
-          DO k=kts,ktf
-            vel = ru(i,k,j)
-            fqx( i,k ) = vel*flux4( field(i-2,k,j), field(i-1,k,j),  &
-                                          field(i  ,k,j), field(i+1,k,j),  &
-                                          vel                     )
+          DO i=i_start,i_start_f-1
+
+            IF(i == ids+1) THEN ! second order
+              DO k=kts,ktf
+                fqx(i,k) = 0.5*(ru(i,k,j)) &
+                       *(field(i,k,j)+field(i-1,k,j))
+              ENDDO
+            ENDIF
+
+            IF(i == ids+2) THEN  ! third order
+              DO k=kts,ktf
+                vel = ru(i,k,j)
+                fqx( i,k ) = vel*flux4( field(i-2,k,j), field(i-1,k,j),  &
+                                              field(i  ,k,j), field(i+1,k,j),  &
+                                              vel                     )
+              ENDDO
+            END IF
+
           ENDDO
 
@@ -3010,21 +3079,25 @@
         IF( degrade_xe ) THEN
 
-          IF( i_end == ide-2 ) THEN ! second order flux next to the boundary
-            i = ide-1
-            DO k=kts,ktf
-              fqx(i,k) = 0.5*(ru(i,k,j))      &
-                     *(field(i,k,j)+field(i-1,k,j))
-            ENDDO
-         ENDIF
-
-          i = ide-2
-          DO k=kts,ktf
-            vel = ru(i,k,j)
-            fqx( i,k ) = vel*flux4( field(i-2,k,j), field(i-1,k,j),  &
-                                          field(i  ,k,j), field(i+1,k,j),  &
-                                          vel                             )
-          ENDDO
-
-        ENDIF
+          DO i = i_end_f+1, i_end+1
+
+            IF( i == ide-1 ) THEN ! second order flux next to the boundary
+              DO k=kts,ktf
+                fqx(i,k) = 0.5*(ru(i,k,j))      &
+                       *(field(i,k,j)+field(i-1,k,j))
+              ENDDO
+           ENDIF
+
+           IF( i == ide-2 ) THEN ! third order flux one in from the boundary
+             DO k=kts,ktf
+               vel = ru(i,k,j)
+               fqx( i,k ) = vel*flux4( field(i-2,k,j), field(i-1,k,j),  &
+                                       field(i  ,k,j), field(i+1,k,j),  &
+                                       vel                             )
+             ENDDO
+           ENDIF
+
+         ENDDO
+
+       ENDIF
 
 !  x flux-divergence into tendency
@@ -3055,5 +3128,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+2)                ) degrade_xs = .false.
+       (its > ids+3)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -3061,8 +3134,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+2)                ) degrade_ys = .false.
+       (jts > jds+3)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-3)                ) degrade_ye = .false.
+       (jte < jde-4)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -3089,4 +3162,5 @@
         j_end_f = jde-3
       ENDIF
+
 
 !  compute fluxes, 5th or 6th order
@@ -3108,4 +3182,5 @@
         ENDDO
 
+
       ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
 
@@ -3186,5 +3261,6 @@
       IF(degrade_xs) then
         i_start = MAX(ids+1,its)
-        i_start_f = i_start+2
+!        i_start_f = i_start+2
+        i_start_f = MIN(i_start+2,ids+3)
       ENDIF
 
@@ -3214,19 +3290,22 @@
         IF( degrade_xs ) THEN
 
-          IF( i_start == ids+1 ) THEN ! second order flux next to the boundary
-            i = ids+1
-            DO k=kts,ktf
-              fqx(i,k) = 0.5*(ru(i,k,j)) &
-                     *(field(i,k,j)+field(i-1,k,j))
-
-            ENDDO
-          ENDIF
-
-          i = ids+2
-          DO k=kts,ktf
-            vel = ru(i,k,j)
-            fqx( i,k ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
-                                          field(i  ,k,j), field(i+1,k,j),  &
-                                          vel                     )
+          DO i=i_start,i_start_f-1
+
+            IF(i == ids+1) THEN ! second order
+              DO k=kts,ktf
+                fqx(i,k) = 0.5*(ru(i,k,j)) &
+                       *(field(i,k,j)+field(i-1,k,j))
+              ENDDO
+            ENDIF
+
+            IF(i == ids+2) THEN  ! third order
+              DO k=kts,ktf
+                vel = ru(i,k,j)
+                fqx( i,k ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
+                                              field(i  ,k,j), field(i+1,k,j),  &
+                                              vel                     )
+              ENDDO
+            END IF
+
           ENDDO
 
@@ -3235,21 +3314,25 @@
         IF( degrade_xe ) THEN
 
-          IF( i_end == ide-2 ) THEN ! second order flux next to the boundary
-            i = ide-1
-            DO k=kts,ktf
-              fqx(i,k) = 0.5*(ru(i,k,j))      &
-                     *(field(i,k,j)+field(i-1,k,j))
-            ENDDO
-         ENDIF
-
-          i = ide-2
-          DO k=kts,ktf
-            vel = ru(i,k,j)
-            fqx( i,k ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
-                                          field(i  ,k,j), field(i+1,k,j),  &
-                                          vel                             )
-          ENDDO
-
-        ENDIF
+          DO i = i_end_f+1, i_end+1
+
+            IF( i == ide-1 ) THEN ! second order flux next to the boundary
+              DO k=kts,ktf
+                fqx(i,k) = 0.5*(ru(i,k,j))      &
+                       *(field(i,k,j)+field(i-1,k,j))
+              ENDDO
+           ENDIF
+
+           IF( i == ide-2 ) THEN ! third order flux one in from the boundary
+             DO k=kts,ktf
+               vel = ru(i,k,j)
+               fqx( i,k ) = vel*flux3( field(i-2,k,j), field(i-1,k,j),  &
+                                       field(i  ,k,j), field(i+1,k,j),  &
+                                       vel                             )
+             ENDDO
+           ENDIF
+
+         ENDDO
+
+       ENDIF
 
 !  x flux-divergence into tendency
@@ -3274,5 +3357,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
+       (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -3280,8 +3363,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
+       (jts > jds+2)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-2)                ) degrade_ye = .false.
+       (jte < jde-3)                ) degrade_ye = .false.
 
 !  begin flux computations
@@ -3376,4 +3459,5 @@
         j_end_f = jde-2
       ENDIF
+
 
     jp1 = 2
@@ -3392,6 +3476,9 @@
       DO k = kts, ktf
       DO i = i_start, i_end
-         fqy(i,k,jp1) = 0.5*rv(i,k,j_end+1)          &
-                *(field(i,k,j_end+1)+field(i,k,j_end))
+         ! Assumes j>j_end_f is ONLY j_end+1 ...
+!         fqy(i,k,jp1) = 0.5*rv(i,k,j_end+1)          &
+!                *(field(i,k,j_end+1)+field(i,k,j_end))
+         fqy(i,k,jp1) = 0.5*rv(i,k,j)          &
+                *(field(i,k,j)+field(i,k,j-1))
       ENDDO
       ENDDO
@@ -3407,6 +3494,6 @@
     END IF
 
+!  y flux-divergence into tendency
     IF ( j > j_start ) THEN
-!  y flux-divergence into tendency
 
       DO k=kts,ktf
@@ -3416,4 +3503,6 @@
       ENDDO
       ENDDO
+
+
     END IF
 
@@ -3434,5 +3523,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
+       (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -3440,8 +3529,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
+       (jts > jds+2)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-2)                ) degrade_ye = .false.
+       (jte < jde-3)                ) degrade_ye = .false.
 
 !  begin flux computations
@@ -3536,4 +3625,5 @@
         j_end_f = jde-2
       ENDIF
+
 
     jp1 = 2
@@ -3552,6 +3642,9 @@
       DO k = kts, ktf
       DO i = i_start, i_end
-         fqy(i,k,jp1) = 0.5*rv(i,k,j_end+1)          &
-                *(field(i,k,j_end+1)+field(i,k,j_end))
+         ! Assumes j>j_end_f is ONLY j_end+1 ...
+!         fqy(i,k,jp1) = 0.5*rv(i,k,j_end+1)          &
+!                *(field(i,k,j_end+1)+field(i,k,j_end))
+         fqy(i,k,jp1) = 0.5*rv(i,k,j)          &
+                *(field(i,k,j)+field(i,k,j-1))
       ENDDO
       ENDDO
@@ -3567,6 +3660,6 @@
     END IF
 
+!  y flux-divergence into tendency
     IF ( j > j_start ) THEN
-!  y flux-divergence into tendency
 
       DO k=kts,ktf
@@ -3576,4 +3669,6 @@
       ENDDO
       ENDDO
+
+
     END IF
 
@@ -3610,4 +3705,5 @@
       i_end   = MIN(ite,ide-1)
 
+      !
       IF ( config_flags%open_ys .or. specified ) j_start = MAX(jds+1,jts)
       IF ( config_flags%open_ye .or. specified ) j_end   = MIN(jde-2,jte)
@@ -3624,4 +3720,9 @@
       ENDDO
    
+
+   ELSE IF ( horz_order == 0 ) THEN
+
+      ! Just in case we want to turn horizontal advection off, we can do it
+
    ELSE
 
@@ -3859,5 +3960,4 @@
       ENDDO
 
-
    ELSE IF (vert_order == 2) THEN    
 
@@ -3890,5 +3990,5 @@
 SUBROUTINE advect_w    ( w, w_old, tendency,            &
                          ru, rv, rom,                   &
-                         mut, config_flags,             &
+                         mut, time_step, config_flags,  &
                          msfu, msfv, msft,              &
                          fzm, fzp,                      &
@@ -3927,4 +4027,6 @@
    REAL ,                                        INTENT(IN   ) :: rdx,  &
                                                                   rdy
+   INTEGER ,                                     INTENT(IN   ) :: time_step
+
 
    ! Local data
@@ -3958,5 +4060,5 @@
       flux3(q_im2, q_im1, q_i, q_ip1, ua) =                     &
            flux4(q_im2, q_im1, q_i, q_ip1, ua) +                &
-           sign(1.,ua)*((q_ip1 - q_im2)-3.*(q_i-q_im1))/12.0
+           sign(1,time_step)*sign(1.,ua)*((q_ip1 - q_im2)-3.*(q_i-q_im1))/12.0
 
       flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =       &
@@ -3966,5 +4068,5 @@
       flux5(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua) =       &
            flux6(q_im3, q_im2, q_im1, q_i, q_ip1, q_ip2, ua)    &
-            -sign(1.,ua)*(                             &
+            -sign(1,time_step)*sign(1.,ua)*(                    &
               (q_ip2-q_im3)-5.*(q_ip1-q_im2)+10.*(q_i-q_im1) )/60.0
 
@@ -4001,8 +4103,585 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
+       (its > ids+3)                ) degrade_xs = .false.
+   IF( config_flags%periodic_x   .or. &
+       config_flags%symmetric_xe .or. &
+       (ite < ide-3)                ) degrade_xe = .false.
+   IF( config_flags%periodic_y   .or. &
+       config_flags%symmetric_ys .or. &
+       (jts > jds+3)                ) degrade_ys = .false.
+   IF( config_flags%periodic_y   .or. &
+       config_flags%symmetric_ye .or. &
+       (jte < jde-4)                ) degrade_ye = .false.
+
+!--------------- y - advection first
+
+      i_start = its
+      i_end   = MIN(ite,ide-1)
+      j_start = jts
+      j_end   = MIN(jte,jde-1)
+
+!  higher order flux has a 5 or 7 point stencil, so compute
+!  bounds so we can switch to second order flux close to the boundary
+
+      j_start_f = j_start
+      j_end_f   = j_end+1
+
+      IF(degrade_ys) then
+        j_start = MAX(jts,jds+1)
+        j_start_f = jds+3
+      ENDIF
+
+      IF(degrade_ye) then
+        j_end = MIN(jte,jde-2)
+        j_end_f = jde-3
+      ENDIF
+
+
+!  compute fluxes, 5th or 6th order
+
+     jp1 = 2
+     jp0 = 1
+
+     j_loop_y_flux_6 : DO j = j_start, j_end+1
+
+      IF( (j >= j_start_f ) .and. (j <= j_end_f) ) THEN
+
+        DO k=kts+1,ktf
+        DO i = i_start, i_end
+          vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
+          fqy( i, k, jp1 ) = vel*flux6(                     &
+                  w(i,k,j-3), w(i,k,j-2), w(i,k,j-1),       &
+                  w(i,k,j  ), w(i,k,j+1), w(i,k,j+2),  vel )
+        ENDDO
+        ENDDO
+
+        k = ktf+1
+        DO i = i_start, i_end
+          vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
+          fqy( i, k, jp1 ) = vel*flux6(                     &
+                  w(i,k,j-3), w(i,k,j-2), w(i,k,j-1),       &
+                  w(i,k,j  ), w(i,k,j+1), w(i,k,j+2),  vel )
+        ENDDO
+
+      ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
+
+            DO k=kts+1,ktf
+            DO i = i_start, i_end
+              fqy(i, k, jp1) = 0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))*          &
+                     (w(i,k,j)+w(i,k,j-1))
+            ENDDO
+            ENDDO
+
+            k = ktf+1
+            DO i = i_start, i_end
+              fqy(i, k, jp1) = 0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))*          &
+                     (w(i,k,j)+w(i,k,j-1))
+            ENDDO
+
+     ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
+
+            DO k=kts+1,ktf
+            DO i = i_start, i_end
+              vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
+              fqy( i, k, jp1 ) = vel*flux4(              &
+                   w(i,k,j-2),w(i,k,j-1),w(i,k,j),w(i,k,j+1),vel )
+            ENDDO
+            ENDDO
+
+            k = ktf+1
+            DO i = i_start, i_end
+              vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
+              fqy( i, k, jp1 ) = vel*flux4(              &
+                   w(i,k,j-2),w(i,k,j-1),w(i,k,j),w(i,k,j+1),vel )
+            ENDDO
+
+     ELSE IF ( j == jde-1 ) THEN  ! 2nd order flux next to north boundary
+
+            DO k=kts+1,ktf
+            DO i = i_start, i_end
+              fqy(i, k, jp1) = 0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))*      &
+                     (w(i,k,j)+w(i,k,j-1))
+            ENDDO
+            ENDDO
+
+            k = ktf+1
+            DO i = i_start, i_end
+              fqy(i, k, jp1) = 0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))*      &
+                     (w(i,k,j)+w(i,k,j-1))
+            ENDDO
+
+     ELSE IF ( j == jde-2 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
+
+            DO k=kts+1,ktf
+            DO i = i_start, i_end
+              vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
+              fqy( i, k, jp1 ) = vel*flux4(             &
+                   w(i,k,j-2),w(i,k,j-1),    &
+                   w(i,k,j),w(i,k,j+1),vel )
+            ENDDO
+            ENDDO
+
+            k = ktf+1
+            DO i = i_start, i_end
+              vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
+              fqy( i, k, jp1 ) = vel*flux4(             &
+                   w(i,k,j-2),w(i,k,j-1),    &
+                   w(i,k,j),w(i,k,j+1),vel )
+            ENDDO
+
+     ENDIF
+
+!  y flux-divergence into tendency
+
+        IF(j > j_start) THEN
+
+          DO k=kts+1,ktf+1
+          DO i = i_start, i_end
+            mrdy=msft(i,j-1)*rdy
+            tendency(i,k,j-1) = tendency(i,k,j-1) - mrdy*(fqy(i,k,jp1)-fqy(i,k,jp0))
+          ENDDO
+          ENDDO
+
+       ENDIF
+
+
+        jtmp = jp1
+        jp1 = jp0
+        jp0 = jtmp
+
+      ENDDO j_loop_y_flux_6
+
+!  next, x - flux divergence
+
+      i_start = its
+      i_end   = MIN(ite,ide-1)
+
+      j_start = jts
+      j_end   = MIN(jte,jde-1)
+
+!  higher order flux has a 5 or 7 point stencil, so compute
+!  bounds so we can switch to second order flux close to the boundary
+
+      i_start_f = i_start
+      i_end_f   = i_end+1
+
+      IF(degrade_xs) then
+        i_start = MAX(ids+1,its)
+!        i_start_f = i_start+2
+        i_start_f = MIN(i_start+2,ids+3)
+      ENDIF
+
+      IF(degrade_xe) then
+        i_end = MIN(ide-2,ite)
+        i_end_f = ide-3
+      ENDIF
+
+!  compute fluxes
+
+      DO j = j_start, j_end
+
+!  5th or 6th order flux
+
+        DO k=kts+1,ktf
+        DO i = i_start_f, i_end_f
+          vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
+          fqx( i,k ) = vel*flux6( w(i-3,k,j), w(i-2,k,j),  &
+                                  w(i-1,k,j), w(i  ,k,j),  &
+                                  w(i+1,k,j), w(i+2,k,j),  &
+                                  vel                     )
+        ENDDO
+        ENDDO
+
+        k = ktf+1
+        DO i = i_start_f, i_end_f
+          vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
+          fqx( i,k ) = vel*flux6( w(i-3,k,j), w(i-2,k,j),  &
+                                  w(i-1,k,j), w(i  ,k,j),  &
+                                  w(i+1,k,j), w(i+2,k,j),  &
+                                  vel                     )
+        ENDDO
+
+!  lower order fluxes close to boundaries (if not periodic or symmetric)
+
+        IF( degrade_xs ) THEN
+
+          DO i=i_start,i_start_f-1
+
+            IF(i == ids+1) THEN ! second order
+              DO k=kts+1,ktf
+                fqx(i,k) = 0.5*(fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)) &
+                                *(w(i,k,j)+w(i-1,k,j))
+              ENDDO
+              k = ktf+1
+              fqx(i,k) = 0.5*((2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)) &
+                     *(w(i,k,j)+w(i-1,k,j))
+            ENDIF
+
+            IF(i == ids+2) THEN  ! third order
+              DO k=kts+1,ktf
+                vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
+                fqx( i,k ) = vel*flux4( w(i-2,k,j), w(i-1,k,j),  &
+                                        w(i  ,k,j), w(i+1,k,j),  &
+                                        vel                     )
+              ENDDO
+              k = ktf+1
+              vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
+              fqx( i,k ) = vel*flux4( w(i-2,k,j), w(i-1,k,j),  &
+                                      w(i  ,k,j), w(i+1,k,j),  &
+                                      vel                     )
+            END IF
+
+          ENDDO
+
+        ENDIF
+
+        IF( degrade_xe ) THEN
+
+          DO i = i_end_f+1, i_end+1
+
+            IF( i == ide-1 ) THEN ! second order flux next to the boundary
+              DO k=kts+1,ktf
+                fqx(i,k) = 0.5*(fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j))      &
+                                  *(w(i,k,j)+w(i-1,k,j))
+              ENDDO
+              k = ktf+1
+              fqx(i,k) = 0.5*((2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j))      &
+                     *(w(i,k,j)+w(i-1,k,j))
+            ENDIF
+
+            IF( i == ide-2 ) THEN ! third order flux one in from the boundary
+              DO k=kts+1,ktf
+                vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
+                fqx( i,k ) = vel*flux4( w(i-2,k,j), w(i-1,k,j),  &
+                                        w(i  ,k,j), w(i+1,k,j),  &
+                                        vel                     )
+              ENDDO
+              k = ktf+1
+              vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
+              fqx( i,k ) = vel*flux4( w(i-2,k,j), w(i-1,k,j),  &
+                                      w(i  ,k,j), w(i+1,k,j),  &
+                                      vel                     )
+            ENDIF
+
+          ENDDO
+
+        ENDIF
+
+!  x flux-divergence into tendency
+
+        DO k=kts+1,ktf+1
+          DO i = i_start, i_end
+            mrdx=msft(i,j)*rdx
+            tendency(i,k,j) = tendency(i,k,j) - mrdx*(fqx(i+1,k)-fqx(i,k))
+          ENDDO
+        ENDDO
+
+      ENDDO
+
+ELSE IF (horz_order == 5 ) THEN
+
+!  determine boundary mods for flux operators
+!  We degrade the flux operators from 3rd/4th order
+!   to second order one gridpoint in from the boundaries for
+!   all boundary conditions except periodic and symmetry - these
+!   conditions have boundary zone data fill for correct application
+!   of the higher order flux stencils
+
+   degrade_xs = .true.
+   degrade_xe = .true.
+   degrade_ys = .true.
+   degrade_ye = .true.
+
+   IF( config_flags%periodic_x   .or. &
+       config_flags%symmetric_xs .or. &
+       (its > ids+3)                ) degrade_xs = .false.
+   IF( config_flags%periodic_x   .or. &
+       config_flags%symmetric_xe .or. &
+       (ite < ide-3)                ) degrade_xe = .false.
+   IF( config_flags%periodic_y   .or. &
+       config_flags%symmetric_ys .or. &
+       (jts > jds+3)                ) degrade_ys = .false.
+   IF( config_flags%periodic_y   .or. &
+       config_flags%symmetric_ye .or. &
+       (jte < jde-4)                ) degrade_ye = .false.
+
+!--------------- y - advection first
+
+      i_start = its
+      i_end   = MIN(ite,ide-1)
+      j_start = jts
+      j_end   = MIN(jte,jde-1)
+
+!  higher order flux has a 5 or 7 point stencil, so compute
+!  bounds so we can switch to second order flux close to the boundary
+
+      j_start_f = j_start
+      j_end_f   = j_end+1
+
+      IF(degrade_ys) then
+        j_start = MAX(jts,jds+1)
+        j_start_f = jds+3
+      ENDIF
+
+      IF(degrade_ye) then
+        j_end = MIN(jte,jde-2)
+        j_end_f = jde-3
+      ENDIF
+
+
+!  compute fluxes, 5th or 6th order
+
+     jp1 = 2
+     jp0 = 1
+
+     j_loop_y_flux_5 : DO j = j_start, j_end+1
+
+      IF( (j >= j_start_f ) .and. (j <= j_end_f) ) THEN
+
+        DO k=kts+1,ktf
+        DO i = i_start, i_end
+          vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
+          fqy( i, k, jp1 ) = vel*flux5(                     &
+                  w(i,k,j-3), w(i,k,j-2), w(i,k,j-1),       &
+                  w(i,k,j  ), w(i,k,j+1), w(i,k,j+2),  vel )
+        ENDDO
+        ENDDO
+
+        k = ktf+1
+        DO i = i_start, i_end
+          vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
+          fqy( i, k, jp1 ) = vel*flux5(                     &
+                  w(i,k,j-3), w(i,k,j-2), w(i,k,j-1),       &
+                  w(i,k,j  ), w(i,k,j+1), w(i,k,j+2),  vel )
+        ENDDO
+
+      ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
+
+            DO k=kts+1,ktf
+            DO i = i_start, i_end
+              fqy(i, k, jp1) = 0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))*          &
+                     (w(i,k,j)+w(i,k,j-1))
+            ENDDO
+            ENDDO
+
+            k = ktf+1
+            DO i = i_start, i_end
+              fqy(i, k, jp1) = 0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))*          &
+                     (w(i,k,j)+w(i,k,j-1))
+            ENDDO
+
+     ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
+
+            DO k=kts+1,ktf
+            DO i = i_start, i_end
+              vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
+              fqy( i, k, jp1 ) = vel*flux3(              &
+                   w(i,k,j-2),w(i,k,j-1),w(i,k,j),w(i,k,j+1),vel )
+            ENDDO
+            ENDDO
+
+            k = ktf+1
+            DO i = i_start, i_end
+              vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
+              fqy( i, k, jp1 ) = vel*flux3(              &
+                   w(i,k,j-2),w(i,k,j-1),w(i,k,j),w(i,k,j+1),vel )
+            ENDDO
+
+     ELSE IF ( j == jde-1 ) THEN  ! 2nd order flux next to north boundary
+
+            DO k=kts+1,ktf
+            DO i = i_start, i_end
+              fqy(i, k, jp1) = 0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))*      &
+                     (w(i,k,j)+w(i,k,j-1))
+            ENDDO
+            ENDDO
+
+            k = ktf+1
+            DO i = i_start, i_end
+              fqy(i, k, jp1) = 0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))*      &
+                     (w(i,k,j)+w(i,k,j-1))
+            ENDDO
+
+     ELSE IF ( j == jde-2 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
+
+            DO k=kts+1,ktf
+            DO i = i_start, i_end
+              vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
+              fqy( i, k, jp1 ) = vel*flux3(             &
+                   w(i,k,j-2),w(i,k,j-1),    &
+                   w(i,k,j),w(i,k,j+1),vel )
+            ENDDO
+            ENDDO
+
+            k = ktf+1
+            DO i = i_start, i_end
+              vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
+              fqy( i, k, jp1 ) = vel*flux3(             &
+                   w(i,k,j-2),w(i,k,j-1),    &
+                   w(i,k,j),w(i,k,j+1),vel )
+            ENDDO
+
+     ENDIF
+
+!  y flux-divergence into tendency
+
+        IF(j > j_start) THEN
+
+          DO k=kts+1,ktf+1
+          DO i = i_start, i_end
+            mrdy=msft(i,j-1)*rdy
+            tendency(i,k,j-1) = tendency(i,k,j-1) - mrdy*(fqy(i,k,jp1)-fqy(i,k,jp0))
+          ENDDO
+          ENDDO
+
+       ENDIF
+
+
+        jtmp = jp1
+        jp1 = jp0
+        jp0 = jtmp
+
+      ENDDO j_loop_y_flux_5
+
+!  next, x - flux divergence
+
+      i_start = its
+      i_end   = MIN(ite,ide-1)
+
+      j_start = jts
+      j_end   = MIN(jte,jde-1)
+
+!  higher order flux has a 5 or 7 point stencil, so compute
+!  bounds so we can switch to second order flux close to the boundary
+
+      i_start_f = i_start
+      i_end_f   = i_end+1
+
+      IF(degrade_xs) then
+        i_start = MAX(ids+1,its)
+!        i_start_f = i_start+2
+        i_start_f = MIN(i_start+2,ids+3)
+      ENDIF
+
+      IF(degrade_xe) then
+        i_end = MIN(ide-2,ite)
+        i_end_f = ide-3
+      ENDIF
+
+!  compute fluxes
+
+      DO j = j_start, j_end
+
+!  5th or 6th order flux
+
+        DO k=kts+1,ktf
+        DO i = i_start_f, i_end_f
+          vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
+          fqx( i,k ) = vel*flux5( w(i-3,k,j), w(i-2,k,j),  &
+                                  w(i-1,k,j), w(i  ,k,j),  &
+                                  w(i+1,k,j), w(i+2,k,j),  &
+                                  vel                     )
+        ENDDO
+        ENDDO
+
+        k = ktf+1
+        DO i = i_start_f, i_end_f
+          vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
+          fqx( i,k ) = vel*flux5( w(i-3,k,j), w(i-2,k,j),  &
+                                  w(i-1,k,j), w(i  ,k,j),  &
+                                  w(i+1,k,j), w(i+2,k,j),  &
+                                  vel                     )
+        ENDDO
+
+!  lower order fluxes close to boundaries (if not periodic or symmetric)
+
+        IF( degrade_xs ) THEN
+
+          DO i=i_start,i_start_f-1
+
+            IF(i == ids+1) THEN ! second order
+              DO k=kts+1,ktf
+                fqx(i,k) = 0.5*(fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)) &
+                                *(w(i,k,j)+w(i-1,k,j))
+              ENDDO
+              k = ktf+1
+              fqx(i,k) = 0.5*((2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)) &
+                     *(w(i,k,j)+w(i-1,k,j))
+            ENDIF
+
+            IF(i == ids+2) THEN  ! third order
+              DO k=kts+1,ktf
+                vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
+                fqx( i,k ) = vel*flux3( w(i-2,k,j), w(i-1,k,j),  &
+                                        w(i  ,k,j), w(i+1,k,j),  &
+                                        vel                     )
+              ENDDO
+              k = ktf+1
+              vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
+              fqx( i,k ) = vel*flux3( w(i-2,k,j), w(i-1,k,j),  &
+                                      w(i  ,k,j), w(i+1,k,j),  &
+                                      vel                     )
+            END IF
+
+          ENDDO
+
+        ENDIF
+
+        IF( degrade_xe ) THEN
+
+          DO i = i_end_f+1, i_end+1
+
+            IF( i == ide-1 ) THEN ! second order flux next to the boundary
+              DO k=kts+1,ktf
+                fqx(i,k) = 0.5*(fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j))      &
+                                  *(w(i,k,j)+w(i-1,k,j))
+              ENDDO
+              k = ktf+1
+              fqx(i,k) = 0.5*((2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j))      &
+                     *(w(i,k,j)+w(i-1,k,j))
+            ENDIF
+
+            IF( i == ide-2 ) THEN ! third order flux one in from the boundary
+              DO k=kts+1,ktf
+                vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
+                fqx( i,k ) = vel*flux3( w(i-2,k,j), w(i-1,k,j),  &
+                                        w(i  ,k,j), w(i+1,k,j),  &
+                                        vel                     )
+              ENDDO
+              k = ktf+1
+              vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
+              fqx( i,k ) = vel*flux3( w(i-2,k,j), w(i-1,k,j),  &
+                                      w(i  ,k,j), w(i+1,k,j),  &
+                                      vel                     )
+            ENDIF
+
+          ENDDO
+
+        ENDIF
+
+!  x flux-divergence into tendency
+
+        DO k=kts+1,ktf+1
+          DO i = i_start, i_end
+            mrdx=msft(i,j)*rdx
+            tendency(i,k,j) = tendency(i,k,j) - mrdx*(fqx(i+1,k)-fqx(i,k))
+          ENDDO
+        ENDDO
+
+      ENDDO
+
+ELSE IF ( horz_order == 4 ) THEN
+
+   degrade_xs = .true.
+   degrade_xe = .true.
+   degrade_ys = .true.
+   degrade_ye = .true.
+
+   IF( config_flags%periodic_x   .or. &
+       config_flags%symmetric_xs .or. &
        (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
-       (ite < ide-3)                ) degrade_xe = .false.
+       (ite < ide-2)                ) degrade_xe = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
